com.fasterxml.jackson.databind.deser

## Class BuilderBasedDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<Object>
    - - com.fasterxml.jackson.databind.deser.BeanDeserializerBase
      - - com.fasterxml.jackson.databind.deser.BuilderBasedDeserializer

All Implemented Interfaces:
  ContextualDeserializer, ResolvableDeserializer, Serializable

    public class BuilderBasedDeserializer
    extends BeanDeserializerBase

Class that handles deserialization using a separate Builder class, which is used for data binding and produces actual deserialized value at the end of data binding.

Note on implementation: much of code has been copied from `BeanDeserializer`; there may be opportunities to refactor this in future.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`JsonDeserializer.None`

### Field Summary

Fields
`protected AnnotatedMethod` `_buildMethod`

### Fields inherited from class com.fasterxml.jackson.databind.deser.BeanDeserializerBase

`_anySetter, _backRefs, _beanProperties, _beanType, _delegateDeserializer, _externalTypeIdHandler, _ignorableProps, _ignoreAllUnknown, _injectables, _needViewProcesing, _nonStandardCreation, _objectIdReader, _propertyBasedCreator, _serializationShape, _subDeserializers, _unwrappedPropertyHandler, _valueInstantiator, _vanillaProcessing, TEMP_PROPERTY_NAME`

### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_valueClass`

### Constructor Summary

Constructors
`` `BuilderBasedDeserializer(BeanDeserializerBuilder builder, BeanDescription beanDesc, BeanPropertyMap properties, Map<String,SettableBeanProperty> backRefs, HashSet<String> ignorableProps, boolean ignoreAllUnknown, boolean hasViews)` Constructor used by `BeanDeserializerBuilder`.
`protected` `BuilderBasedDeserializer(BuilderBasedDeserializer src)` Copy-constructor that can be used by sub-classes to allow copy-on-write styling copying of settings of an existing instance.
`protected` `BuilderBasedDeserializer(BuilderBasedDeserializer src, boolean ignoreAllUnknown)`
`` `BuilderBasedDeserializer(BuilderBasedDeserializer src, HashSet<String> ignorableProps)`
`protected` `BuilderBasedDeserializer(BuilderBasedDeserializer src, NameTransformer unwrapper)`
`` `BuilderBasedDeserializer(BuilderBasedDeserializer src, ObjectIdReader oir)`

### Method Summary

Methods
`protected Object` `_deserialize(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt, Object builder)`
`protected Object` `_deserializeUsingPropertyBased(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)` Method called to deserialize bean using "property-based creator": this means that a non-default constructor or factory method is called, and then possibly other setters.
`protected BeanAsArrayBuilderDeserializer` `asArrayDeserializer()` Fluent factory for creating a variant that can handle POJO output as a JSON Array.
`Object` `deserialize(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)` Main deserialization method for bean-based objects (POJOs).
`Object` `deserialize(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt, Object builder)` Secondary deserialization method, called in cases where POJO instance is created as part of deserialization, potentially after collecting some or all of the properties to set.
`Object` `deserializeFromObject(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)` General version used when handling needs more advanced features.
`protected Object` `deserializeUsingPropertyBasedWithExternalTypeId(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)`
`protected Object` `deserializeUsingPropertyBasedWithUnwrapped(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)`
`protected Object` `deserializeWithExternalTypeId(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)`
`protected Object` `deserializeWithExternalTypeId(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt, Object bean)`
`protected Object` `deserializeWithUnwrapped(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)` Method called when there are declared "unwrapped" properties which need special handling
`protected Object` `deserializeWithUnwrapped(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt, Object bean)`
`protected Object` `deserializeWithView(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt, Object bean, Class<?> activeView)`
`protected Object` `finishBuild(DeserializationContext ctxt, Object builder)`
`JsonDeserializer<Object>` `unwrappingDeserializer(NameTransformer unwrapper)` Method that will return deserializer instance that is able to handle "unwrapped" value instances If no unwrapped instance can be constructed, will simply return this object as-is.
`BuilderBasedDeserializer` `withIgnorableProperties(HashSet<String> ignorableProps)`
`BuilderBasedDeserializer` `withObjectIdReader(ObjectIdReader oir)`

### Methods inherited from class com.fasterxml.jackson.databind.deser.BeanDeserializerBase

`_convertObjectId, _findSubclassDeserializer, _handleTypedObjectId, _resolvedObjectIdProperty, _resolveInnerClassValuedProperty, _resolveManagedReferenceProperty, _resolveUnwrappedProperty, createContextual, creatorProperties, deserializeFromArray, deserializeFromBoolean, deserializeFromDouble, deserializeFromNumber, deserializeFromObjectId, deserializeFromObjectUsingNonDefault, deserializeFromString, deserializeWithObjectId, deserializeWithType, findBackReference, findConvertingDeserializer, findProperty, findProperty, findProperty, getBeanClass, getKnownPropertyNames, getObjectIdReader, getPropertyCount, getValueInstantiator, getValueType, handledType, handleIgnoredProperty, handlePolymorphic, handleUnknownProperties, handleUnknownProperty, handleUnknownVanilla, hasProperty, hasViews, injectValues, isCachable, properties, replaceProperty, resolve, wrapAndThrow, wrapAndThrow, wrapInstantiationProblem`

### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_hasTextualNull, _isNaN, _isNegInf, _isPosInf, _parseBoolean, _parseBooleanFromNumber, _parseBooleanPrimitive, _parseByte, _parseDate, _parseDouble, _parseDoublePrimitive, _parseFloat, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseShort, _parseShortPrimitive, _parseString, findConvertingContentDeserializer, findDeserializer, getValueClass, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`getDelegatee, getEmptyValue, getNullValue, replaceDelegatee`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _buildMethod

    protected final AnnotatedMethod _buildMethod

### Constructor Detail

#### BuilderBasedDeserializer

    public BuilderBasedDeserializer(BeanDeserializerBuilder builder,
                            BeanDescription beanDesc,
                            BeanPropertyMap properties,
                            Map<String,SettableBeanProperty> backRefs,
                            HashSet<String> ignorableProps,
                            boolean ignoreAllUnknown,
                            boolean hasViews)

Constructor used by `BeanDeserializerBuilder`.

#### BuilderBasedDeserializer

    protected BuilderBasedDeserializer(BuilderBasedDeserializer src)

Copy-constructor that can be used by sub-classes to allow copy-on-write styling copying of settings of an existing instance.

#### BuilderBasedDeserializer

    protected BuilderBasedDeserializer(BuilderBasedDeserializer src,
                            boolean ignoreAllUnknown)

#### BuilderBasedDeserializer

    protected BuilderBasedDeserializer(BuilderBasedDeserializer src,
                            NameTransformer unwrapper)

#### BuilderBasedDeserializer

    public BuilderBasedDeserializer(BuilderBasedDeserializer src,
                            ObjectIdReader oir)

#### BuilderBasedDeserializer

    public BuilderBasedDeserializer(BuilderBasedDeserializer src,
                            HashSet<String> ignorableProps)

### Method Detail

#### unwrappingDeserializer

    public JsonDeserializer<Object> unwrappingDeserializer(NameTransformer unwrapper)

Description copied from class: `JsonDeserializer`
Method that will return deserializer instance that is able to handle "unwrapped" value instances If no unwrapped instance can be constructed, will simply return this object as-is.

Default implementation just returns 'this' indicating that no unwrapped variant exists

Specified by:
  `unwrappingDeserializer` in class `BeanDeserializerBase`

#### withObjectIdReader

    public BuilderBasedDeserializer withObjectIdReader(ObjectIdReader oir)

Specified by:
  `withObjectIdReader` in class `BeanDeserializerBase`

#### withIgnorableProperties

    public BuilderBasedDeserializer withIgnorableProperties(HashSet<String> ignorableProps)

Specified by:
  `withIgnorableProperties` in class `BeanDeserializerBase`

#### asArrayDeserializer

    protected BeanAsArrayBuilderDeserializer asArrayDeserializer()

Description copied from class: `BeanDeserializerBase`
Fluent factory for creating a variant that can handle POJO output as a JSON Array. Implementations may ignore this request if no such input is possible.

Specified by:
  `asArrayDeserializer` in class `BeanDeserializerBase`

#### finishBuild

    protected final Object finishBuild(DeserializationContext ctxt,
                     Object builder)
                                throws IOException

Throws:
  `IOException`

#### deserialize

    public final Object deserialize(com.fasterxml.jackson.core.JsonParser jp,
                     DeserializationContext ctxt)
                             throws IOException,
                                    com.fasterxml.jackson.core.JsonProcessingException

Main deserialization method for bean-based objects (POJOs).

Specified by:
  `deserialize` in class `JsonDeserializer<Object>`
Parameters:
  `jp` - Parsed used for reading JSON content
  `ctxt` - Context that can be used to access information about this deserialization activity.
Returns:
  Deserialized value
Throws:
  `IOException`
  `com.fasterxml.jackson.core.JsonProcessingException`

#### deserialize

    public Object deserialize(com.fasterxml.jackson.core.JsonParser jp,
                     DeserializationContext ctxt,
                     Object builder)
                       throws IOException,
                              com.fasterxml.jackson.core.JsonProcessingException

Secondary deserialization method, called in cases where POJO instance is created as part of deserialization, potentially after collecting some or all of the properties to set.

Overrides:
  `deserialize` in class `JsonDeserializer<Object>`
Throws:
  `IOException`
  `com.fasterxml.jackson.core.JsonProcessingException`

#### _deserialize

    protected final Object _deserialize(com.fasterxml.jackson.core.JsonParser jp,
                      DeserializationContext ctxt,
                      Object builder)
                                 throws IOException,
                                        com.fasterxml.jackson.core.JsonProcessingException

Throws:
  `IOException`
  `com.fasterxml.jackson.core.JsonProcessingException`

#### deserializeFromObject

    public Object deserializeFromObject(com.fasterxml.jackson.core.JsonParser jp,
                               DeserializationContext ctxt)
                                 throws IOException,
                                        com.fasterxml.jackson.core.JsonProcessingException

General version used when handling needs more advanced features.

Specified by:
  `deserializeFromObject` in class `BeanDeserializerBase`
Throws:
  `IOException`
  `com.fasterxml.jackson.core.JsonProcessingException`

#### _deserializeUsingPropertyBased

    protected final Object _deserializeUsingPropertyBased(com.fasterxml.jackson.core.JsonParser jp,
                                        DeserializationContext ctxt)
                                                   throws IOException,
                                                          com.fasterxml.jackson.core.JsonProcessingException

Method called to deserialize bean using "property-based creator": this means that a non-default constructor or factory method is called, and then possibly other setters. The trick is that values for creator method need to be buffered, first; and due to non-guaranteed ordering possibly some other properties as well.

Specified by:
  `_deserializeUsingPropertyBased` in class `BeanDeserializerBase`
Throws:
  `IOException`
  `com.fasterxml.jackson.core.JsonProcessingException`

#### deserializeWithView

    protected final Object deserializeWithView(com.fasterxml.jackson.core.JsonParser jp,
                             DeserializationContext ctxt,
                             Object bean,
                             Class<?> activeView)
                                        throws IOException,
                                               com.fasterxml.jackson.core.JsonProcessingException

Throws:
  `IOException`
  `com.fasterxml.jackson.core.JsonProcessingException`

#### deserializeWithUnwrapped

    protected Object deserializeWithUnwrapped(com.fasterxml.jackson.core.JsonParser jp,
                                  DeserializationContext ctxt)
                                       throws IOException,
                                              com.fasterxml.jackson.core.JsonProcessingException

Method called when there are declared "unwrapped" properties which need special handling

Throws:
  `IOException`
  `com.fasterxml.jackson.core.JsonProcessingException`

#### deserializeWithUnwrapped

    protected Object deserializeWithUnwrapped(com.fasterxml.jackson.core.JsonParser jp,
                                  DeserializationContext ctxt,
                                  Object bean)
                                       throws IOException,
                                              com.fasterxml.jackson.core.JsonProcessingException

Throws:
  `IOException`
  `com.fasterxml.jackson.core.JsonProcessingException`

#### deserializeUsingPropertyBasedWithUnwrapped

    protected Object deserializeUsingPropertyBasedWithUnwrapped(com.fasterxml.jackson.core.JsonParser jp,
                                                    DeserializationContext ctxt)
                                                         throws IOException,
                                                                com.fasterxml.jackson.core.JsonProcessingException

Throws:
  `IOException`
  `com.fasterxml.jackson.core.JsonProcessingException`

#### deserializeWithExternalTypeId

    protected Object deserializeWithExternalTypeId(com.fasterxml.jackson.core.JsonParser jp,
                                       DeserializationContext ctxt)
                                            throws IOException,
                                                   com.fasterxml.jackson.core.JsonProcessingException

Throws:
  `IOException`
  `com.fasterxml.jackson.core.JsonProcessingException`

#### deserializeWithExternalTypeId

    protected Object deserializeWithExternalTypeId(com.fasterxml.jackson.core.JsonParser jp,
                                       DeserializationContext ctxt,
                                       Object bean)
                                            throws IOException,
                                                   com.fasterxml.jackson.core.JsonProcessingException

Throws:
  `IOException`
  `com.fasterxml.jackson.core.JsonProcessingException`

#### deserializeUsingPropertyBasedWithExternalTypeId

    protected Object deserializeUsingPropertyBasedWithExternalTypeId(com.fasterxml.jackson.core.JsonParser jp,
                                                         DeserializationContext ctxt)
                                                              throws IOException,
                                                                     com.fasterxml.jackson.core.JsonProcessingException

Throws:
  `IOException`
  `com.fasterxml.jackson.core.JsonProcessingException`